zoukankan      html  css  js  c++  java
  • Codeforces Round #381 (Div. 2) D. Alyona and a tree dfs序+树状数组

    D. Alyona and a tree
    time limit per test
    2 seconds
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    Alyona has a tree with n vertices. The root of the tree is the vertex 1. In each vertex Alyona wrote an positive integer, in the vertex i she wrote ai. Moreover, the girl wrote a positive integer to every edge of the tree (possibly, different integers on different edges).

    Let's define dist(v, u) as the sum of the integers written on the edges of the simple path from v to u.

    The vertex v controls the vertex u (v ≠ u) if and only if u is in the subtree of v and dist(v, u) ≤ au.

    Alyona wants to settle in some vertex. In order to do this, she wants to know for each vertex v what is the number of vertices u such thatv controls u.

    Input

    The first line contains single integer n (1 ≤ n ≤ 2·105).

    The second line contains n integers a1, a2, ..., an (1 ≤ ai ≤ 109) — the integers written in the vertices.

    The next (n - 1) lines contain two integers each. The i-th of these lines contains integers pi and wi (1 ≤ pi ≤ n1 ≤ wi ≤ 109) — the parent of the (i + 1)-th vertex in the tree and the number written on the edge between pi and (i + 1).

    It is guaranteed that the given graph is a tree.

    Output

    Print n integers — the i-th of these numbers should be equal to the number of vertices that the i-th vertex controls.

    Examples
    input
    5
    2 5 1 4 6
    1 7
    1 1
    3 5
    3 6
    output
    1 0 1 0 0
    input
    5
    9 7 8 6 5
    1 1
    2 1
    3 1
    4 1
    output
    4 3 2 1 0
    Note

    In the example test case the vertex 1 controls the vertex 3, the vertex 3 controls the vertex 5 (note that is doesn't mean the vertex 1controls the vertex 5).

     题意:n个点的一棵树,每个点有一个权值,满足一个条件,点v的子树中u的个数,条件是u->v的最短路径权值和<=a[u];

     思路:dfs序写法:

             dis[i]为根->i的最短距离,条件->    dis[u]-dis[v]<=a[u];

        将条件转化一下:    dis[v]>=dis[u]-a[u];

        可以预处理出b[u]=dis[u]-a[u],从而转化为子树问题,子树中b[u]小于等于dis[v]的个数;

        树上二分写法:

        将条件转化一下:    dis[v]>=dis[u]-a[u];

        由于每个点的权值都是非负数,所以dis是单调递增的,二分dis,找到该点,前缀和处理;

    #pragma comment(linker, "/STACK:1024000000,1024000000")
    #include<iostream>
    #include<cstdio>
    #include<cmath>
    #include<string>
    #include<queue>
    #include<algorithm>
    #include<stack>
    #include<cstring>
    #include<vector>
    #include<list>
    #include<set>
    #include<map>
    using namespace std;
    #define ll long long
    #define pi (4*atan(1.0))
    #define eps 1e-14
    #define bug(x)  cout<<"bug"<<x<<endl;
    const int N=2e5+10,M=1e6+10,inf=2147483647;
    const ll INF=1e18+10,mod=2147493647;
    struct is
    {
        int v,next;
        ll w;
    }edge[N<<1];
    int head[N],edg;
    int in[N],out[N],tot;
    ll dis[N],a[N];
    void init()
    {
        memset(head,-1,sizeof(head));
        edg=0;
        tot=0;
    }
    void add(int u,int v,ll w)
    {
        edg++;
        edge[edg].v=v;
        edge[edg].w=w;
        edge[edg].next=head[u];
        head[u]=edg;
    }
    void dfs(int u,int fa,ll val)
    {
        tot++;
        in[u]=tot;
        dis[u]=val;
        for(int i=head[u];i!=-1;i=edge[i].next)
        {
            int v=edge[i].v;
            ll w=edge[i].w;
            if(v==fa)continue;
            dfs(v,u,val+w);
        }
        out[u]=tot;
    }
    struct treearray
    {
        int tree[N];
        void init()
        {
            memset(tree,0,sizeof(tree));
        }
        int lowbit(int x)
        {
            return x&-x;
        }
        void update(int x,int c)
        {
            while(x<N)
            {
                tree[x]+=c;
                x+=lowbit(x);
            }
        }
        int query(int x)
        {
            int sum=0;
            while(x)
            {
                sum+=tree[x];
                x-=lowbit(x);
            }
            return sum;
        }
    };
    struct p
    {
        ll x;
        int pos;
        bool operator <(const p &a)const
        {
            return x<a.x;
        }
    }b[N];
    struct q
    {
        int l,r,pos;
        ll x;
        bool operator <(const q &a)const
        {
            return x<a.x;
        }
    }q[N];
    int ans[N];
    int main()
    {
        init();
        int n;
        scanf("%d",&n);
        for(int i=1;i<=n;i++)
            scanf("%lld",&a[i]);
        for(int i=2;i<=n;i++)
        {
            int v;ll w;
            scanf("%d%lld",&v,&w);
            add(v,i,w);
            add(i,v,w);
        }
        dfs(1,-1,0LL);
        for(int i=1;i<=n;i++)
            b[in[i]].x=dis[i]-a[i],b[i].pos=i;
        //for(int i=1;i<=n;i++)
        //cout<<in[i]<<" "<<out[i]<<endl;
        //cout<<"yyyy"<<endl;
        sort(b+1,b+1+n);
        for(int i=1;i<=n;i++)
        {
            q[i].l=in[i];
            q[i].r=out[i];
            q[i].pos=i;
            q[i].x=dis[i];
        }
        sort(q+1,q+1+n);
        //for(int i=1;i<=n;i++)
            //cout<<b[i].x<<" "<<b[i].pos<<endl;
        //cout<<"zzzzz"<<endl;
        int st=1;
        treearray tree;
        tree.init();
        for(int i=1;i<=n;i++)
        {
            //cout<<q[i].l<<" "<<q[i].r<<" "<<q[i].x<<" "<<q[i].pos<<endl;
            while(st<=n&&q[i].x>=b[st].x)
            {
                tree.update(b[st].pos,1);
                st++;
            }
            ans[q[i].pos]=tree.query(q[i].r)-tree.query(q[i].l);
        }
        for(int i=1;i<=n;i++)
            printf("%d ",ans[i]);
        return 0;
    }
  • 相关阅读:
    JS和Flash相互调用
    xml的应用
    随机验证码
    模块 time
    第一天 注册成功
    我的第一篇博客
    git
    2018-02-27
    25
    建站之星
  • 原文地址:https://www.cnblogs.com/jhz033/p/6420845.html
Copyright © 2011-2022 走看看